<?php
/***************************************************************************
 *                                dashboard_install.php
 *                            -------------------
 *   begin                : Friday, Sept 10, 2004
 *   copyright            : (C) 2004 safeTsurfa
 *   email                : safetsurfa@hotmail.com
 *
 *   $Id: dashboard_install.php,v 1.0.0 2004/09/11 00:00:00 safeTsurfa Exp $
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
define('IN_PHPBB', true); 

$phpbb_root_path = './'; 
$dashboard_schemas = $phpbb_root_path . 'dashboard_install/';

include($phpbb_root_path . 'extension.inc'); 
include($phpbb_root_path . 'common.'.$phpEx); 

$forum_url = append_sid("index.$phpEx");
$my_dashboard_topic = "http://www.phpbb.com/phpBB/viewtopic.php?t=122005";

// 
// Start session management 
// 
$userdata = session_pagestart($user_ip, PAGE_INDEX); 
init_userprefs($userdata); 
// 
// End session management 
// 

include($phpbb_root_path.'language/lang_' . $board_config['default_lang'] . '/lang_admin.'.$phpEx);

$dashboard_dbms = array(
	'mysql'=> array(
		'LABEL'			=> 'MySQL 3.x',
		'SCHEMA'		=> 'mysql', 
		'DELIM'			=> ';',
		'COMMENTS'		=> 'remove_remarks'
	), 
	'mysql4' => array(
		'LABEL'			=> 'MySQL 4.x',
		'SCHEMA'		=> 'mysql', 
		'DELIM'			=> ';', 
		'COMMENTS'		=> 'remove_remarks'
	), 
	'postgres' => array(
		'LABEL'			=> 'PostgreSQL 7.x',
		'SCHEMA'		=> 'postgres', 
		'DELIM'			=> ';', 
		'COMMENTS'		=> 'remove_comments'
	), 
	'mssql' => array(
		'LABEL'			=> 'MS SQL Server 7/2000',
		'SCHEMA'		=> 'mssql', 
		'DELIM'			=> 'GO', 
		'COMMENTS'		=> 'remove_comments'
	),
	'msaccess' => array(
		'LABEL'			=> 'MS Access [ ODBC ]',
		'SCHEMA'		=> '', 
		'DELIM'			=> '', 
		'COMMENTS'		=> ''
	),
	'mssql-odbc' =>	array(
		'LABEL'			=> 'MS SQL Server [ ODBC ]',
		'SCHEMA'		=> 'mssql', 
		'DELIM'			=> 'GO',
		'COMMENTS'		=> 'remove_comments'
	)
);

if( !$userdata['session_logged_in'] ) 
{ 
	redirect(append_sid("login.$phpEx?redirect=dashboard_mysql_install.$phpEx", true));
} 

if( $userdata['user_level'] != ADMIN ) 
{ 
   message_die(GENERAL_MESSAGE, 'You are not authorised to access this page'); 
} 
$dbms = ( isset($dbms) ) ? $dbms : $HTTP_POST_VARS['dbms'];
$page_title = 'My_Dashboard 1.2.0 - SQL Installation'; 
if ( intval($HTTP_POST_VARS['go']) != 1 )
{
	if ( empty($dbms) )
	{
		include($phpbb_root_path . 'includes/page_header.'.$phpEx); 


		$dbms_select = '<select name="dbms">';
		while (list($dbms_name, $details) = @each($dashboard_dbms))
		{
			$selected = ($dbms_name == $dbms) ? 'selected="selected"' : '';
			$dbms_select .= '<option value="' . $dbms_name . '">' . $details['LABEL'] . '</option>';
		}
		$dbms_select .= '</select>';

print<<<PRINTEND

		<table width="100%" cellspacing="0" cellpadding="2" border="0" class="forumline">
		  <tr>
			<th class="thTop">Installing database tables</th>
		  </tr>
			<tr>
				<td class="row1" align="center"><form action="" method="post"><span class="gen"><br />Please choose the database connection type.
		<br /><br />
		$dbms_select
		<br />
		<input type="submit" name="confirm" value="Continue" class="mainoption" /></span></form></td>
			</tr>
		</table>

PRINTEND;

		include($phpbb_root_path . 'includes/page_tail.'.$phpEx); 
	}
	else
	{
		include($phpbb_root_path . 'includes/page_header.'.$phpEx); 

		$table_type = " ".$dashboard_dbms[$dbms]['LABEL'];
print<<<PRINTEND
		<table width="100%" cellspacing="0" cellpadding="2" border="0" class="forumline">
		  <tr>
			<th class="thTop">Installing database tables</th>
		  </tr>
			<tr>
				<td class="row1" align="center"><form action="" method="post"><span class="gen"><br />Are you sure you want to install the My_Dashboad$table_type tables?
		<br /><br />
		<input type="hidden" name="go" value="1">
		<input type="hidden" name="dbms" value="$dbms">
		<input type="submit" name="confirm" value="Yes" class="mainoption" />&nbsp;&nbsp;<input type="submit" name="cancel" value="No" class="liteoption" /></span></form></td>
			</tr>
		</table>

PRINTEND;

		include($phpbb_root_path . 'includes/page_tail.'.$phpEx); 
	}
}
else
{
	include($phpbb_root_path . 'includes/page_header.'.$phpEx); 

print<<<PRINTEND
	<table width="100%" cellspacing="0" cellpadding="2" border="0" class="forumline">
	  <tr>
		<th class="thTop">Installing database tables</th>
	  </tr>
	  <tr>
		<td>
		  <span class="genmed">
			<ul type="disc">

PRINTEND;
	if (!empty($dbms))
	{
		switch($dbms)
		{
			case 'msaccess':
			case 'mssql-odbc':
				$check_exts = 'odbc';
				$check_other = 'odbc';
				break;

			case 'mssql':
				$check_exts = 'mssql';
				$check_other = 'sybase';
				break;

			case 'mysql':
			case 'mysql4':
				$check_exts = 'mysql';
				$check_other = 'mysql';
				break;

			case 'postgres':
				$check_exts = 'pgsql';
				$check_other = 'pgsql';
				break;
		}

		if (!extension_loaded($check_exts) && !extension_loaded($check_other))
		{	
			?>
			<div class="genmed" align="center"><?php echo $lang['Install_No_Ext']; ?><br />
		  If you have any problems, please visit the <a href="<?php echo $dashboard_topic; ?>" target="_new">My Dashboard Ultra support thread</a> and ask for help.</div>
			<?php
			include($phpbb_root_path . 'includes/page_tail.'.$phpEx); 
			exit;
		}
	}

	$dbms_schema = $dashboard_schemas . $dashboard_dbms[$dbms]['SCHEMA'] . '_schema.sql';
	$remove_remarks = $dashboard_dbms[$dbms]['COMMENTS'];;
	$delimiter = $dashboard_dbms[$dbms]['DELIM']; 

	if ($dbms == 'msaccess')
	{
		?>
		<div class="genmed" align="center">Please check the documentation for how to add the tables to your existing MS-Access database.</div>
		<?php
		include($phpbb_root_path . 'includes/page_tail.'.$phpEx); 
		exit;	
	}
	else
	{
		// Load in the sql parser
		include($phpbb_root_path.'includes/sql_parse.'.$phpEx);

		// Ok we have the db info go ahead and read in the relevant schema
		// and work on building the table.. probably ought to provide some
		// kind of feedback to the user as we are working here in order
		// to let them know we are actually doing something.
		$sql_query = @fread(@fopen($dbms_schema, 'r'), @filesize($dbms_schema));
		$sql_query = preg_replace('/phpbb_/', $table_prefix, $sql_query);

		$sql_query = $remove_remarks($sql_query);
		$sql_query = split_sql_file($sql_query, $delimiter);

		for ($i = 0; $i < sizeof($sql_query); $i++)
		{
			if (trim($sql_query[$i]) != '')
			{
				if (!($result = $db->sql_query($sql_query[$i])))
				{
					$error = $db->sql_error();
	
					print('<li>' . nl2br(trim($sql_query[$i])) . '<br /><ul type="square"><li><font color="#FF0000"><b>Error:</b></font> ' . $error['message'] . '</li></ul></li><br />');
					$sql_error = true;
					break;
				}
				else
				{
					print('<li>' . nl2br(trim($sql_query[$i])) . '<br /><ul type="square"><li><font color="#00AA00"><b>Successful</b></font></li></ul></li><br />');
				}
			}
		}
	}

print<<<PRINTEND
			</ul>
		  </span>
		</td>
	  </tr>
	  <tr>
		<td class="catBottom" height="28">&nbsp;</td>
	  </tr>
	</table>

	<br />
	<br />
PRINTEND;

	if ( !$sql_error )
	{
print<<<PRINTEND
	<table width="100%" cellspacing="0" cellpadding="2" border="0" class="forumline">
	  <tr>
		<th class="thTop">Installation complete</th>
	  </tr>
	  <tr>
		<td align="center">
		  <span class="genmed">Please delete this file and the dashboard_install folder.</span>
		</td>
	  </tr>
	  <tr>
		<td class="catBottom" height="28">&nbsp;</td>
	  </tr>
	</table>

PRINTEND;
	}
	else
	{
print<<<PRINTEND
	<table width="100%" cellspacing="1" cellpadding="2" border="0" class="forumline">
	  <tr>
		<th class="thHead">Error</th>
	  </tr>
	  <tr>
		<td align="center">
		  <span class="genmed">Please make sure your database doesn't have conflicting tables or data, and that you can properly connection, then try again.</span>
		</td>
	  </tr>
	  <tr>
		<td class="catBottom" height="28">&nbsp;</td>
	  </tr>
	</table>

PRINTEND;
	}
	include($phpbb_root_path . 'includes/page_tail.'.$phpEx); 
}
?>