/*

  mssql_schema.sql for My Dashboard Ultra (c) 2004, safeTsurfa

 $Id: mssql_schema.sql,v 1.00.0 2004/09/11 00:00:00 safeTsurfa Exp $

*/

BEGIN TRANSACTION
GO

CREATE TABLE [phpbb_my_dashboard] (
	[config_name] [varchar] (255) NULL ,
	[config_value] [varchar] (255) NULL
) ON [PRIMARY]
GO

CREATE TABLE [phpbb_approve_forums] ( 
	[forum_id] [smallint] NOT NULL IDENTITY (1, 1) , 
	[enabled] [smallint] NOT NULL , 

INSERT INTO phpbb_my_dashboard (config_name, config_value) VALUES ('version','1.2.0');
INSERT INTO phpbb_my_dashboard (config_name, config_value) VALUES ('active','1');
INSERT INTO phpbb_my_dashboard (config_name, config_value) VALUES ('display','3');
INSERT INTO phpbb_my_dashboard (config_name, config_value) VALUES ('avatars','1');
INSERT INTO phpbb_my_dashboard (config_name, config_value) VALUES ('emails','');
INSERT INTO phpbb_my_dashboard (config_name, config_value) VALUES ('messages','');
GO

ALTER TABLE [phpbb_users] WITH NOCHECK ADD (
	[dashboard_show] [tinyint(1)] UNSIGNED NOT NULL ,
	[dashboard_mode] [tinyint(1)] UNSIGNED NOT NULL ,
	[dashboard_avatar] [tinyint(1)] UNSIGNED NOT NULL ,
	[dashboard_open] [tinyint(1)] UNSIGNED NOT NULL
)
GO

ALTER TABLE [phpbb_users] WITH NOCHECK ADD
	CONSTRAINT [DF_phpbb_users_dashboard_show] DEFAULT (1) FOR [dashboard_show],
	CONSTRAINT [DF_phpbb_users_dashboard_mode] DEFAULT (1) FOR [dashboard_mode],
	CONSTRAINT [DF_phpbb_users_dashboard_avatar] DEFAULT (1) FOR [dashboard_avatar],
	CONSTRAINT [DF_phpbb_users_dashboard_open] DEFAULT (1) FOR [dashboard_open]
GO

COMMIT
GO