############################################################## 
## Hack Title:    My Dashboard Ultra
## Author: safeTsurfa < safetsurfa@hotmail.com > (n/a) http://www.safetsurfa.co.uk
## Description: Adds a user panel to the top of the board with contact admin links, 
## message alerts, plus posting statistics with linked search results. The display 
## has minimize and restore, and a user preferences panel in the profile. The board 
## and contact links can also be configured from the Admin Panel which overrides 
## user preferences. If the user is logged out, the login box is shown. 
## 
## Hack Version:   1.2.0 
## Compatibility:   2.0.8 - 2.0.10 
## Support:  http://www.phpbbhacks.com/forums 
## Copyright:  Copyright  2004 My Dashboard Ultra 1.2.0 - safeTsurfa
## 
## Installation Level:   Intermediate 
## Installation Time:   20 minutes 
## 
## Files To Edit: 9 
##	privmsg.php 
##	search.php 
##	includes/constants.php 
##	includes/functions.php 
##	includes/page_header.php
##	includes/usercp_register.php
##	language/lang_english/lang_main.php 
##	templates/subSilver/overall_header.tpl 
##	templates/subSilver/profile_add_body.tpl 
## Included Files: 8 
## 	dashboard_install.php
## 	dashboard.php
##	admin/admin_dashboard.php
##	includes/functions_dashboard.php
##	language/lang_english/lang_dashboard.php 
##	templates/subSilver/admin/admin_dashboard_body.tpl
##	templates/subSilver/images/dashboard_close.gif
##	templates/subSilver/images/dashboard_open.gif
############################################################## 
## You downloaded this hack from phpBBHacks.com, the #1 source for phpBB related downloads. 
## Please visit http://www.phpbbhacks.com/forums for support. 
############################################################## 
## This hack is released under the GPL License. 
## This hack can be freely used, but not distributed, without permission. 
## Intellectual Property is retained by the hack author(s) listed above. 
############################################################## 
## Author Notes: 
## Tested on phpBB 2.0.10 and 2.0.8, but might also work as low as version 2.0.6. 
## It installs successfully using Nuttzy's EasyMOD, but SQL changes are separate. 
## 
## This MOD is designed for use with standard phpBB installations. It has not been 
## tested on portals or pre-modded boards, and is not guaranteed to work with them. 
## Support will NOT be given where this is installed on a portal or pre-modded board. 
## If you need help within those environments, you must ask the author or supplier 
## of the portal or pre-modded board you are using. 
## 
## The images in the templates/subSilver/images folder are 16*15 pixels. There are 
## larger 20*18 px images in the 'Large Images' folder for styles which need them. 
## The images use the background from graphics supplied in the subSilver SDK. 
## The subSilver SDK is (c) phpBB Group and not released under the GPL. 
## 
## The dashboard_install.php file edits the necessary tables in MySql, MSSQL or 
## PostgreSQLdatabases. Upload the file and dashboard_install folder to your phpBB 
## root folder, then in your browser enter the line below, using your own site URL 
## and replacing 'phpbb2' with the name of your phpBB folder if needed: 
## http://www.yoursite.com/phpbb2/dashboard_install.php 
## REMEMBER to delete the file and folder from your phpBB folder when you are done! 
## 
## Alternatively, you can make the changes manually, using the SQL queries below 
## and replacing the 'phpbb_' table prefix with your own table prefix if needed. 
## 
## -----[ SQL ]------------------------------------------ 
##  
## ALTER TABLE phpbb_users
## ADD dashboard_show TINYINT(1) UNSIGNED DEFAULT '1' NOT NULL,
## ADD dashboard_mode TINYINT(1) UNSIGNED DEFAULT '1' NOT NULL,
## ADD dashboard_avatar TINYINT(1) UNSIGNED DEFAULT '1' NOT NULL,
## ADD dashboard_open TINYINT(1) UNSIGNED DEFAULT '1' NOT NULL;
## 
## CREATE TABLE phpbb_my_dashboard (
##     config_name varchar(255) NOT NULL,
##     config_value varchar(255) NOT NULL,
##     PRIMARY KEY (config_name)
## );
## 
## INSERT INTO phpbb_my_dashboard (config_name, config_value) VALUES ('version','1.2.0');
## INSERT INTO phpbb_my_dashboard (config_name, config_value) VALUES ('active','1');
## INSERT INTO phpbb_my_dashboard (config_name, config_value) VALUES ('display','3');
## INSERT INTO phpbb_my_dashboard (config_name, config_value) VALUES ('avatars','1');
## INSERT INTO phpbb_my_dashboard (config_name, config_value) VALUES ('emails','');
## INSERT INTO phpbb_my_dashboard (config_name, config_value) VALUES ('messages','');
## 
## Many thanks to the following translators for their valuable contributions: 
## - Nina3Jungs < http://forum.novembermamis2001.de/signature.php > - German file. 
## - StickyKid (Jason Hacker) http://www.loveloli.net - Traditional Chinese file. 
## NOTE: If you use non-English languages, you must also edit lang_main.php for each 
## of these. The changes are explained at the top of each lang_dashboard.php file. 
## 
## Greets and thanks also fly out to:
## Fredol < fredol@lovewithsmg.com > for some bug fixes and code proof reading, 
## Drathbun < www.momentsoflight.com > for help with sql queries syntax, and to 
## shof515 < www.shof515.com > for testing of the update patches on his board. 
## Acknowledgement and credit to John B Abela's Welcome and Avatar on Index MOD, 
## from which the code for the image display on the dashboard is adapted. 
############################################################## 
## MOD History: 
## 
## 2004-08-14 - Version 1.0.0 
## - Roll-up mod combining Basic and Advanced editions into a single installation. 
## - Now includes display mode selection and disable options in the user profile. 
## - Revamped old code to pre-define display in php file and reduce tpl editing. 
##
## 2004-08-15 - Version 1.0.1 
## - Fixed a small bug to make avatar display obey ACP general config restrictions. 
## - Added switch to hide show avatar option if avatars disabled for board or user. 
## 
## 2004-08-17 - Version 1.0.2 
## - Now EasyMOD compliant with test installation done on a clean board. 
## 
## 2004-08-25 - Version 1.1.0 
## - Added minimize and restore buttons feature to the dashboard display. 
## 
## 2004-08-27 - Version 1.1.1 
## - Rewrite of some code to make processing more efficient. 
## 
## 2004-09-21 - Version 1.2.0 
## - Added dashboard configuration page to the Administration Panel. 
## - Transferred language edits to a custom lang_dashboard.php file. 
## - Created sql installer for use with MySql, MSSQL and PostgreSQL. 
## - Fixed incorrect user style reference for personal avatar display. 
## - Code change for admin mail contact on forums with board email disabled. 
## - Some changes for compatibility with language syntax for German users. 
############################################################## 
## Before Adding This MOD To Your Forum, You Should Back Up All Files Related To This MOD 
############################################################## 

#
#-----[ COPY ]------------------------------------------
#
copy phpbb2/dashboard.php to dashboard.php
copy phpbb2/admin/admin_dashboard.php to admin/admin_dashboard.php
copy phpbb2/includes/functions_dashboard.php to includes/functions_dashboard.php
copy phpbb2/language/lang_english/lang_dashboard.php to language/lang_english/lang_dashboard.php
copy phpbb2/templates/subSilver/admin/admin_dashboard_body.tpl to templates/subSilver/admin/admin_dashboard_body.tpl
copy phpbb2/templates/subSilver/images/*.gif to templates/subSilver/images/

# 
#-----[ OPEN ]------------------------------------------ 
# 
privmsg.php

# 
#-----[ FIND ]------------------------------------ 
# 
$userdata['user_new_privmsg'] = 0;
$userdata['user_unread_privmsg'] = ( $userdata['user_new_privmsg'] + $userdata['user_unread_privmsg'] );

# 
#-----[ REPLACE WITH ]------------------------------------------ 
# 
$userdata['user_unread_privmsg'] = ( $userdata['user_new_privmsg'] + $userdata['user_unread_privmsg'] );
$userdata['user_new_privmsg'] = 0;

# 
#-----[ OPEN ]------------------------------------------ 
# 
search.php

# 
#-----[ FIND ]------------------------------------ 
# 
	//
	// Cycle through options ...
	//
	if ( $search_id == 'newposts' || $search_id == 'egosearch' || $search_id == 'unanswered' || $search_keywords != '' || $search_author != '' )

# 
#-----[ IN-LINE FIND ]------------------------------------ 
# 
$search_id == 'unanswered'

# 
#-----[ IN-LINE AFTER, ADD ]------------------------------------ 
# 
 || $search_id == 'egounanswered' || $search_id == 'egotopics' || $search_id == 'egoreplies' || $search_id == 'newtopics' || $search_id == 'newreplies' || $search_id == 'watched' || $search_id == 'announce' || $search_id == 'newannounce'

# 
#-----[ FIND ]------------------------------------ 
# 
		else
		{
			message_die(GENERAL_MESSAGE, $lang['No_search_match']);
		}

		//
		// Finish building query (for all combinations)
		// and run it ...
		//

# 
#-----[ BEFORE, ADD ]------------------------------------ 
# 
		//
		// START MOD: My Dashboard Ultra by safeTsurfa
		//
		else if ( $search_id == 'egounanswered' )
		{
			if ( $auth_sql != '' )
			{
				$sql = "SELECT t.topic_id, f.forum_id
					FROM " . TOPICS_TABLE . "  t, " . FORUMS_TABLE . " f
					WHERE t.topic_replies = 0 
						AND t.forum_id = f.forum_id
						AND t.topic_moved_id = 0
						AND t.topic_poster = " . $userdata['user_id'] . "
						AND $auth_sql";
			}
			else
			{
				$sql = "SELECT topic_id 
					FROM " . TOPICS_TABLE . "  
					WHERE topic_replies = 0 
						AND topic_moved_id = 0
						AND topic_poster = " . $userdata['user_id'];
			}
				
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not obtain post ids', '', __LINE__, __FILE__, $sql);
			}

			$search_ids = array();
			while( $row = $db->sql_fetchrow($result) )
			{
				$search_ids[] = $row['topic_id'];
			}
			$db->sql_freeresult($result);

			$total_match_count = count($search_ids);

			//
			// Basic requirements
			//
			$show_results = 'topics';
			$sort_by = 0;
			$sort_dir = 'DESC';
		}
		else if ( $search_id == 'egotopics' )
		{
			if ( $auth_sql != '' )
			{
				$sql = "SELECT t.topic_id, f.forum_id
					FROM " . TOPICS_TABLE . "  t, " . FORUMS_TABLE . " f
					WHERE t.forum_id = f.forum_id
						AND t.topic_moved_id = 0
						AND t.topic_poster = " . $userdata['user_id'] . "
						AND $auth_sql";
			}
			else
			{
				$sql = "SELECT topic_id 
					FROM " . TOPICS_TABLE . "  
					WHERE topic_moved_id = 0
						AND topic_poster = " . $userdata['user_id'];
			}
				
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not obtain post ids', '', __LINE__, __FILE__, $sql);
			}

			$search_ids = array();
			while( $row = $db->sql_fetchrow($result) )
			{
				$search_ids[] = $row['topic_id'];
			}
			$db->sql_freeresult($result);

			$total_match_count = count($search_ids);

			//
			// Basic requirements
			//
			$show_results = 'topics';
			$sort_by = 0;
			$sort_dir = 'DESC';
		}
		else if ( $search_id == 'egoreplies' )
		{
			if ( $auth_sql != '' )
			{
				$sql = "SELECT p.topic_id, f.forum_id
					FROM " . POSTS_TABLE . " p, " . FORUMS_TABLE . " f, " . TOPICS_TABLE . " t
					WHERE t.forum_id = f.forum_id
						AND t.topic_id = p.topic_id
						AND t.topic_moved_id = 0
						AND p.post_id != t.topic_first_post_id
						AND p.poster_id = " . $userdata['user_id'] . "
						AND $auth_sql";
			}
			else
			{
				$sql = "SELECT p.topic_id
					FROM " . POSTS_TABLE . " p, " . TOPICS_TABLE . "  t 
					WHERE t.topic_id = p.topic_id
						AND t.topic_moved_id = 0
						AND p.post_id != t.topic_first_post_id
						AND p.poster_id = " . $userdata['user_id'];
			}
				
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not obtain post ids', '', __LINE__, __FILE__, $sql);
			}

			$search_ids = array();
			while( $row = $db->sql_fetchrow($result) )
			{
				$search_ids[] = $row['topic_id'];
			}
			$db->sql_freeresult($result);

			$total_match_count = count($search_ids);

			//
			// Basic requirements
			//
			$show_results = 'topics';
			$sort_by = 0;
			$sort_dir = 'DESC';
		}
		else if ( $search_id == 'newtopics' )
		{
			if ( $auth_sql != '' )
			{
				$sql = "SELECT t.topic_id, f.forum_id
					FROM " . TOPICS_TABLE . "  t, " . FORUMS_TABLE . " f
					WHERE t.topic_time >= " . $userdata['user_lastvisit'] . "
					AND t.forum_id = f.forum_id
						AND t.topic_moved_id = 0
						AND $auth_sql";
			}
			else
			{
				$sql = "SELECT topic_id 
					FROM " . TOPICS_TABLE . "  
					WHERE topic_time >= " . $userdata['user_lastvisit'] . "
						AND topic_moved_id = 0";
			}
				
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not obtain post ids', '', __LINE__, __FILE__, $sql);
			}

			$search_ids = array();
			while( $row = $db->sql_fetchrow($result) )
			{
				$search_ids[] = $row['topic_id'];
			}
			$db->sql_freeresult($result);

			$total_match_count = count($search_ids);

			//
			// Basic requirements
			//
			$show_results = 'topics';
			$sort_by = 0;
			$sort_dir = 'DESC';
		}
		else if ( $search_id == 'newreplies' )
		{
			if ( $auth_sql != '' )
			{
				$sql = "SELECT p.topic_id, f.forum_id
					FROM " . POSTS_TABLE . " p, " . FORUMS_TABLE . " f, " . TOPICS_TABLE . " t
					WHERE t.forum_id = f.forum_id
						AND t.topic_id = p.topic_id
						AND t.topic_moved_id = 0
						AND p.post_id != t.topic_first_post_id
						AND p.post_time >= " . $userdata['user_lastvisit'] . "
						AND $auth_sql";
			}
			else
			{
				$sql = "SELECT p.topic_id
					FROM " . POSTS_TABLE . " p, " . TOPICS_TABLE . "  t 
					WHERE t.topic_id = p.topic_id
						AND t.topic_moved_id = 0
						AND p.post_id != t.topic_first_post_id
						AND p.post_time >= " . $userdata['user_lastvisit'];
			}
				
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not obtain post ids', '', __LINE__, __FILE__, $sql);
			}

			$search_ids = array();
			while( $row = $db->sql_fetchrow($result) )
			{
				$search_ids[] = $row['topic_id'];
			}
			$db->sql_freeresult($result);

			$total_match_count = count($search_ids);

			//
			// Basic requirements
			//
			$show_results = 'topics';
			$sort_by = 0;
			$sort_dir = 'DESC';
		}
		else if ( $search_id == 'watched' )
		{
			if ( $auth_sql != '' )
			{
				$sql = "SELECT t.topic_id, f.forum_id
					FROM " . TOPICS_WATCH_TABLE . "  t, " . TOPICS_TABLE . "  t2, " . FORUMS_TABLE . " f
					WHERE t2.topic_id = t.topic_id
						AND t.user_id = " . $userdata['user_id'] . "
						AND t2.forum_id = f.forum_id
						AND t2.topic_moved_id = 0
						AND $auth_sql";
			}
			else
			{
				$sql = "SELECT t.topic_id 
					FROM " . TOPICS_WATCH_TABLE . "  t, " . TOPICS_TABLE . "  t2  
					WHERE t2.topic_id = t.topic_id
						AND t.user_id = " . $userdata['user_id'] . "
						AND t2.topic_moved_id = 0";
			}
				
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not obtain post ids', '', __LINE__, __FILE__, $sql);
			}

			$search_ids = array();
			while( $row = $db->sql_fetchrow($result) )
			{
				$search_ids[] = $row['topic_id'];
			}
			$db->sql_freeresult($result);

			$total_match_count = count($search_ids);

			//
			// Basic requirements
			//
			$show_results = 'topics';
			$sort_by = 0;
			$sort_dir = 'DESC';
		}
		else if ( $search_id == 'announce' )
		{
			if ( $auth_sql != '' )
			{
				$sql = "SELECT t.topic_id, f.forum_id
					FROM " . TOPICS_TABLE . "  t, " . FORUMS_TABLE . " f
					WHERE t.forum_id = f.forum_id
						AND t.topic_moved_id = 0
						AND t.topic_type = 2
						AND $auth_sql";
			}
			else
			{
				$sql = "SELECT topic_id 
					FROM " . TOPICS_TABLE . "  
					WHERE topic_moved_id = 0
						AND topic_type = 2";
			}
				
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not obtain post ids', '', __LINE__, __FILE__, $sql);
			}

			$search_ids = array();
			while( $row = $db->sql_fetchrow($result) )
			{
				$search_ids[] = $row['topic_id'];
			}
			$db->sql_freeresult($result);

			$total_match_count = count($search_ids);

			//
			// Basic requirements
			//
			$show_results = 'topics';
			$sort_by = 0;
			$sort_dir = 'DESC';
		}
		else if ( $search_id == 'newannounce' )
		{
			if ( $auth_sql != '' )
			{
				$sql = "SELECT t.topic_id, f.forum_id
					FROM " . TOPICS_TABLE . "  t, " . FORUMS_TABLE . " f
					WHERE t.topic_time >= " . $userdata['user_lastvisit'] . "
						AND t.forum_id = f.forum_id
						AND t.topic_moved_id = 0
						AND t.topic_type = 2
						AND $auth_sql";
			}
			else
			{
				$sql = "SELECT topic_id 
					FROM " . TOPICS_TABLE . "
					WHERE topic_time >= " . $userdata['user_lastvisit'] . " 
						AND topic_moved_id = 0
						AND topic_type = 2";
			}
				
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not obtain post ids', '', __LINE__, __FILE__, $sql);
			}

			$search_ids = array();
			while( $row = $db->sql_fetchrow($result) )
			{
				$search_ids[] = $row['topic_id'];
			}
			$db->sql_freeresult($result);

			$total_match_count = count($search_ids);

			//
			// Basic requirements
			//
			$show_results = 'topics';
			$sort_by = 0;
			$sort_dir = 'DESC';
		}
		//
		// END MOD: My Dashboard Ultra by safeTsurfa
		//

# 
#-----[ OPEN ]------------------------------------------ 
# 
includes/functions.php 

# 
#-----[ FIND ]------------------------------------ 
# 
function get_db_stat($mode)
{
	global $db;

# 
#-----[ AFTER, ADD ]------------------------------------ 
# 
	global $userdata;

# 
#-----[ FIND ]------------------------------------ 
# 
		case 'postcount':
		case 'topiccount':
			$sql = "SELECT SUM(forum_topics) AS topic_total, SUM(forum_posts) AS post_total
				FROM " . FORUMS_TABLE;
			break;

# 
#-----[ AFTER, ADD ]------------------------------------ 
# 
		//
		// START MOD: My Dashboard Ultra by safeTsurfa
		//
		case 'userwatched':
			$sql = "SELECT COUNT(topic_id) AS user_watched
				FROM " . TOPICS_WATCH_TABLE . "
				WHERE user_id = " . $userdata['user_id'];
			break;

		case 'usertopics':
			$sql = "SELECT COUNT(topic_id) AS user_topics
				FROM " . TOPICS_TABLE . "
				WHERE topic_poster = " . $userdata['user_id'];
			break;

		case 'userunanswered':
			$sql = "SELECT COUNT(topic_id) AS user_unanswered
				FROM " . TOPICS_TABLE . "
				WHERE topic_replies = 0
				AND topic_poster = " . $userdata['user_id'];
			break;

		case 'newposttotal':
			$sql = "SELECT COUNT(post_id) AS newpost_total
				FROM " . POSTS_TABLE . "
				WHERE post_time > " . $userdata['user_lastvisit'];
			break;

		case 'newtopictotal':
			$sql = "SELECT COUNT(distinct p.post_id) AS newtopic_total
				FROM " . POSTS_TABLE . " p, " . TOPICS_TABLE . " t
				WHERE p.post_time > " . $userdata['user_lastvisit'] . "
				AND p.post_id = t.topic_first_post_id";
			break;

		case 'unansweredtotal':
			$sql = "SELECT COUNT(topic_id) AS unanswered_total
				FROM " . TOPICS_TABLE . "
				WHERE topic_replies = 0";
			break;

		case 'newannouncementtotal':
			$sql = "SELECT COUNT(distinct t.topic_id) AS newannouncement_total
				FROM " . TOPICS_TABLE . " t, " . POSTS_TABLE . " p
				WHERE t.topic_type = 2
				AND p.post_time > " . $userdata['user_lastvisit'] . "
				AND p.post_id = t.topic_first_post_id";
			break;
		case 'announcementtotal':
			$sql = "SELECT COUNT(distinct t.topic_id) AS announcement_total
				FROM " . TOPICS_TABLE . " t, " . POSTS_TABLE . " p
				WHERE t.topic_type = 2
				AND p.post_id = t.topic_first_post_id";
			break;
		//
		// END MOD: My Dashboard Ultra by safeTsurfa
		//

# 
#-----[ FIND ]------------------------------------ 
# 
		case 'topiccount':
			return $row['topic_total'];
			break;

# 
#-----[ AFTER, ADD ]------------------------------------ 
# 
		//
		// START MOD: My Dashboard Ultra by safeTsurfa
		//
		case 'userwatched':
			return $row['user_watched'];
			break;
		case 'usertopics':
			return $row['user_topics'];
			break;
		case 'userunanswered':
			return $row['user_unanswered'];
			break;
		case 'newposttotal':
			return $row['newpost_total'];
			break;
		case 'newtopictotal':
			return $row['newtopic_total'];
			break;
		case 'unansweredtotal':
			return $row['unanswered_total'];
			break;
		case 'newannouncementtotal':
			return $row['newannouncement_total'];
			break;
		case 'announcementtotal':
			return $row['announcement_total'];
			break;
		//
		// END MOD: My Dashboard Ultra by safeTsurfa
		//

# 
#-----[ FIND ]------------------------------------ 
# 
function encode_ip($dotquad_ip)

# 
#-----[ BEFORE, ADD ]------------------------------------ 
# 
// 
// START MOD: My Dashboard Ultra by safeTsurfa 
// 
// 
// Get Template Value 
// 
function get_template_name($style) 
{ 
   global $db, $board_config, $template, $images, $phpbb_root_path; 

   $sql = "SELECT template_name 
      FROM " . THEMES_TABLE . " 
      WHERE themes_id = $style"; 
   if ( !($result = $db->sql_query($sql)) ) 
   { 
      message_die(CRITICAL_ERROR, 'Could not query database for theme info'); 
   } 

   if ( !($row = $db->sql_fetchrow($result)) ) 
   { 
      message_die(CRITICAL_ERROR, "Could not get theme data for themes_id [$style]"); 
   } 
   $template_name = $row['template_name'] ; 

   return $template_name; 
} 
// 
// END MOD: My Dashboard Ultra by safeTsurfa 
// 

#
#-----[ OPEN ]------------------------------------------
#
includes/constants.php

#
#-----[ FIND ]------------------------------------------
#
define('PAGE_GROUPCP', -11);

#
#-----[ AFTER, ADD ]------------------------------------------
#
define('PAGE_DASHBOARD', -1140);

# 
#-----[ FIND ]------------------------------------ 
# 
define('VOTE_USERS_TABLE', $table_prefix.'vote_voters');

# 
#-----[ AFTER, ADD ]------------------------------------ 
# 
define('DASHBOARD_TABLE', $table_prefix.'my_dashboard');

# 
#-----[ OPEN ]------------------------------------------ 
# 
includes/page_header.php

# 
#-----[ FIND ]------------------------------------ 
# 
//
// Parse and show the overall header.
//
$template->set_filenames(array(
	'overall_header' => ( empty($gen_simple_header) ) ? 'overall_header.tpl' : 'simple_header.tpl')
);

# 
#-----[ AFTER, ADD ]------------------------------------ 
# 
// 
// START MOD: My Dashboard Ultra by safeTsurfa 
// 
if( $userdata['session_logged_in'] ) 
{ 
   $myavatar_img = ''; 
   if ( $userdata['dashboard_avatar'] && $userdata['user_avatar_type'] && $userdata['user_allowavatar'] ) 
   { 
      switch( $userdata['user_avatar_type'] ) 
      { 
      case USER_AVATAR_UPLOAD: 
         $myavatar_img = ( $board_config['allow_avatar_upload'] ) ? '<img src="' . $board_config['avatar_path'] . '/' . $userdata['user_avatar'] . '" alt="" border="0" />' : ''; 
         break; 
      case USER_AVATAR_REMOTE: 
         $myavatar_img = ( $board_config['allow_avatar_remote'] ) ? '<img src="' . $userdata['user_avatar'] . '" alt="" border="0" />' : ''; 
         break; 
      case USER_AVATAR_GALLERY: 
         $myavatar_img = ( $board_config['allow_avatar_local'] ) ? '<img src="' . $board_config['avatar_gallery_path'] . '/' . $userdata['user_avatar'] . '" alt="" border="0" />' : ''; 
         break; 
      } 
   } 
   if ($myavatar_img == '') 
   { 
   // 
   // Set up style 
   // 
      if ( !$board_config['override_user_style'] ) 
      { 
         if ( $userdata['user_style'] > 0 ) 
         { 
            $template_name = get_template_name($userdata['user_style']); 
            $myavatar_img = '<img src="'. $phpbb_root_path . 'templates/' . $template_name . '/images/whosonline.gif" >'; 
         } 
      } 
      else 
      { 
         $template_name = get_template_name($board_config['default_style']); 
         $myavatar_img = '<img src="'. $phpbb_root_path . 'templates/' . $template_name . '/images/whosonline.gif" >'; 
      } 
   } 

   if ( !$board_config['override_user_style'] ) 
   { 
      if ( $userdata['user_style'] > 0 ) 
      { 
         $template_name = get_template_name($userdata['user_style']); 
         $dashboardcloseimg = '<img src="'. $phpbb_root_path . 'templates/' . $template_name . '/images/dashboard_close.gif" align="absmiddle" border="0" alt="' . $lang['Dashboard_minimize'] . '" title="' . $lang['Dashboard_minimize'] . '" />';
         $dashboardopenimg = '<img src="'. $phpbb_root_path . 'templates/' . $template_name . '/images/dashboard_open.gif" align="absmiddle" border="0" alt="' . $lang['Dashboard_restore'] . '" title="' . $lang['Dashboard_restore'] . '" />';
      } 
   } 
   else 
   { 
      $template_name = get_template_name($board_config['default_style']); 
      $dashboardcloseimg = '<img src="'. $phpbb_root_path . 'templates/' . $template_name . '/images/dashboard_close.gif" align="absmiddle" border="0" alt="' . $lang['Dashboard_minimize'] . '" title="' . $lang['Dashboard_minimize'] . '" />';
      $dashboardopenimg = '<img src="'. $phpbb_root_path . 'templates/' . $template_name . '/images/dashboard_open.gif" align="absmiddle" border="0" alt="' . $lang['Dashboard_restore'] . '" title="' . $lang['Dashboard_restore'] . '" />';
   } 
}
// 
// END MOD: My Dashboard Ultra by safeTsurfa 
// 

# 
#-----[ FIND ]------------------------------------ 
# 
else
{
	$icon_pm = $images['pm_no_new_msg'];
	$l_privmsgs_text = $lang['Login_check_pm'];
	$l_privmsgs_text_unread = '';
	$s_privmsg_new = 0;
}

# 
#-----[ AFTER, ADD ]------------------------------------ 
# 
//
// START MOD: My Dashboard Ultra by safeTsurfa
//
$sql = "SELECT *
    FROM " . DASHBOARD_TABLE;
if(!$result = $db->sql_query($sql))
{
    message_die(CRITICAL_ERROR, "Could not query dashboard config information", "", __LINE__, __FILE__, $sql);
}
else
{
    while( $row = $db->sql_fetchrow($result) )
    {
        $config_name = $row['config_name'];
        $config_value = $row['config_value'];
        $default_config[$config_name] = $config_value;

        $dashboarddata[$config_name] = ( isset($HTTP_POST_VARS[$config_name]) ) ? $HTTP_POST_VARS[$config_name] : $default_config[$config_name];
    }

    $db->sql_freeresult($result);
}

if( $userdata['session_logged_in'] && $dashboarddata['active'] ) 
{

    if ( !file_exists(@phpbb_realpath($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_dashboard.' . $phpEx)) ) 
    { 
        include($phpbb_root_path . 'language/lang_english/lang_dashboard.' . $phpEx); 
    }
    else 
    { 
        include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_dashboard.' . $phpEx); 
    } 

    $template->assign_block_vars('switch_dashboard_active', array());

    if( $userdata['dashboard_show'] ) 
    {
        $template->assign_block_vars('switch_dashboard_active.switch_dashboard_show', array());

        if( !$userdata['dashboard_open'] ) 
        { 
            $l_dashboard = '<span class="cattitle"><a href="' . append_sid("dashboard.$phpEx") . '">' . $dashboardopenimg . '</a>&nbsp;' . $lang['Dashboard'] . '</span>';
        }
        else
        {
            $sql = "SELECT user_id, user_email
                FROM " . USERS_TABLE . " 
                WHERE username = '" . str_replace("\'", "''", $dashboarddata['emails']) . "'";
                if(!$result = $db->sql_query($sql))
                {
                    message_die(GENERAL_ERROR, $lang['Dashboard_email_error'], '', __LINE__, __FILE__, $sql);
                }

            if( !$board_config['board_email_form'] )
            {
                $contactemail = '';
                if ( $row = $db->sql_fetchrow($result) )
                {
                    $contactemail = ( ( $contactemail != '' ) ? ', ' : '' ) . $row['user_email'];
                }
                else
                {
                    $contactemail = ( ( $contactemail != '' ) ? ', ' : '' ) . $board_config['board_email'];
                }
                $db->sql_freeresult($result);
            }
            else
            {
                $contactemail = '';
                if ( $row = $db->sql_fetchrow($result) )
                {
                    $contactemail = ( ( $contactemail != '' ) ? ', ' : '' ) . $row['user_id'];
                }
                else
                {
                    $contactemail = 2;
                }
                $db->sql_freeresult($result);
            }

            $sql = "SELECT user_id
                FROM " . USERS_TABLE . " 
                WHERE username = '" . str_replace("\'", "''", $dashboarddata['messages']) . "'";
                if(!$result = $db->sql_query($sql))
                {
                    message_die(GENERAL_ERROR, $lang['Dashboard_message_error'], '', __LINE__, __FILE__, $sql);
                }
            $contactepm = '';
            if ( $row = $db->sql_fetchrow($result) )
            {
                $contactpm = ( ( $contactpm != '' ) ? ', ' : '' ) . $row['user_id'];
            }
            else
            {
                $contactpm = 2;
            }
            $db->sql_freeresult($result);

            $template->assign_block_vars('switch_dashboard_active.switch_dashboard_show.switch_dashboard_open', array());
            $l_dashboard = '<span class="cattitle"><a href="' . append_sid("dashboard.$phpEx") . '">' . $dashboardcloseimg . '</a>&nbsp;' . $lang['Dashboard'] . '</span>';

            $user_private_message = $userdata['user_new_privmsg'];
            $name_link = '<a href="' . append_sid("profile.$phpEx?mode=editprofile") . '" title="' . $lang['Edit_profile'] . '" />' . $userdata['username'] . '</a>'; 
            $user_private_message = $userdata['user_new_privmsg'];
            $unread_private_message = ( $userdata['user_new_privmsg'] + $userdata['user_unread_privmsg'] );
            $user_watched_topics = get_db_stat('userwatched');
            $total_user_topics = get_db_stat('usertopics');
            $total_user_replies = ( $userdata['user_posts'] - $total_user_topics );
            $user_unanswered_posts = get_db_stat('userunanswered');
            $total_new_posts = get_db_stat('newposttotal');
            $total_new_topics = get_db_stat('newtopictotal');
            $total_new_replies = ( $total_new_posts - $total_new_topics );
            $total_unanswered_posts = get_db_stat('unansweredtotal');
            $new_announcement_posts = get_db_stat('newannouncementtotal');
            $total_announcement_posts = get_db_stat('announcementtotal');

            if ( $user_private_message == 0 )
            {
                $l_user_private_message_s = $lang['User_messages_zero_total'];
            }
            else if ( $user_private_message == 1 )
            {
                $l_user_private_message_s = $lang['User_message_total'];
            }
            else
            {
                $l_user_private_message_s = $lang['User_messages_total'];
            }

            if ( $unread_private_message == 0 )
            {
                $l_unread_private_message_s = $lang['Unread_messages_zero_total'];
            }
            else if ( $unread_private_message == 1 )
            {
                $l_unread_private_message_s = $lang['Unread_message_total'];
            }
            else
            {
                $l_unread_private_message_s = $lang['Unread_messages_total'];
            }

            if ( $user_watched_topics == 0 )
            {
                $l_user_watched_topics_s = $lang['User_watched_topics_zero_total'];
            }
            else if ( $user_watched_topics == 1 )
            {
                $l_user_watched_topics_s = $lang['User_watched_topic_total'];
            }
            else
            {
                $l_user_watched_topics_s = $lang['User_watched_topics_total'];
            }

            if ( $userdata['user_posts'] == 0 )
            {
                $l_user_posts_total_s = $lang['User_posts_zero_total'];
            }
            else if ( $userdata['user_posts'] == 1 )
            {
                $l_user_posts_total_s = $lang['User_post_total'];
            }
            else
            {
                $l_user_posts_total_s = $lang['User_posts_total'];
            }

            if ( $total_user_topics == 0 )
            {
                $l_user_topics_total_s = $lang['User_topics_zero_total'];
            }
            else if ( $total_user_topics == 1 )
            {
                $l_user_topics_total_s = $lang['User_topic_total'];
            }
            else
            {
                $l_user_topics_total_s = $lang['User_topics_total'];
            }

            if ( $total_user_replies == 0 )
            {
                $l_user_replies_total_s = $lang['User_replies_zero_total'];
            }
            else if ( $total_user_replies == 1 )
            {
                $l_user_replies_total_s = $lang['User_reply_total'];
            }
            else
            {
                $l_user_replies_total_s = $lang['User_replies_total'];
            }

            if ( $user_unanswered_posts == 0 )
            {
                $l_user_unanswered_posts_s = $lang['User_unanswered_posts_zero_total'];
            }
            else if ( $user_unanswered_posts == 1 )
            {
                $l_user_unanswered_posts_s = $lang['User_unanswered_post_total'];
            }
            else
            {
                $l_user_unanswered_posts_s = $lang['User_unanswered_posts_total'];
            }

            if ( $total_new_posts == 0 )
            {
                $l_new_posts_total_s = $lang['New_posts_zero_total'];
            }
            else if ( $total_new_posts == 1 )
            {
                $l_new_posts_total_s = $lang['New_post_total'];
            }
            else
            {
                $l_new_posts_total_s = $lang['New_posts_total'];
            }

            if ( $total_new_topics == 0 )
            {
                $l_new_topics_total_s = $lang['New_topics_zero_total'];
            }
            else if ( $total_new_topics == 1 )
            {
                $l_new_topics_total_s = $lang['New_topic_total'];
            }
            else
            {
                $l_new_topics_total_s = $lang['New_topics_total'];
            }

            if ( $total_new_replies == 0 )
            {
                $l_new_replies_total_s = $lang['New_replies_zero_total'];
            }
            else if ( $total_new_replies == 1 )
            {
                $l_new_replies_total_s = $lang['New_reply_total'];
            }
            else
            {
                $l_new_replies_total_s = $lang['New_replies_total'];
            }

            if ( $total_unanswered_posts == 0 )
            {
                $l_unanswered_posts_s = $lang['Unanswered_posts_zero_total'];
            }
            else if ( $total_unanswered_posts == 1 )
            {
                $l_unanswered_posts_s = $lang['Unanswered_post_total'];
            }
            else
            {
                $l_unanswered_posts_s = $lang['Unanswered_posts_total'];
            }

            if ( $new_announcement_posts == 0 )
            {
                $l_new_announcement_posts_s = $lang['New_announcement_posts_zero_total'];
            }
            else if ( $new_announcement_posts == 1 )
            {
                $l_new_announcement_posts_s = $lang['New_announcement_post_total'];
            }
            else
            {
                $l_new_announcement_posts_s = $lang['New_announcement_posts_total'];
            }

            if ( $total_announcement_posts == 0 )
            {
                $l_announcement_total_s = $lang['Total_announcements_zero_total'];
                $l_announcement_posts_s = $lang['Announcement_posts_zero_total'];
            }
            else if ( $total_announcement_posts == 1 )
            {
                $l_announcement_total_s = $lang['Total_announcement_total'];
                $l_announcement_posts_s = $lang['Announcement_posts_total'];
            }
            else
            {
                $l_announcement_total_s = $lang['Total_announcements_total'];
                $l_announcement_posts_s = $lang['Announcement_posts_total'];
            }

            $l_user_private_message = sprintf($l_user_private_message_s, '<a href="' . append_sid('privmsg.'.$phpEx.'?folder=inbox') . '" class="nav" title="' . $lang['Read_pm'] . '">' . $user_private_message . '</a>');
            $l_unread_private_message = sprintf($l_unread_private_message_s, '<a href="' . append_sid('privmsg.'.$phpEx.'?folder=inbox') . '" class="nav" title="' . $lang['Read_pm'] . '">' . $unread_private_message . '</a>');
            if( !$board_config['board_email_form'] )
            {
                $l_email_admin = '<a href="mailto:' . $contactemail . '" class="nav" title="' . $lang['Send_email_msg'] . '">' . $lang['Email'] . '</a>';
            }
            else
            {
                $l_email_admin = sprintf('<a href="' . append_sid('profile.'.$phpEx.'?mode=email&u=' . $contactemail . '') . '" class="nav" title="' . $lang['Send_email_msg'] . '">' . $lang['Email'] . '</a>');
            }
            $l_pm_admin = sprintf('<a href="' . append_sid('privmsg.'.$phpEx.'?mode=post&u=' . $contactpm . '') . '" class="nav" title="' . $lang['Send_private_message'] . '">' . $lang['Message'] . '</a>');

            $l_user_watched_topics = sprintf($l_user_watched_topics_s, '<a href="' . append_sid('search.'.$phpEx.'?search_id=watched') . '" class="nav" title="' . $lang['View_results'] . '">' . $user_watched_topics . '</a>');
            $l_user_posts_total = sprintf($l_user_posts_total_s, '<a href="' . append_sid('search.'.$phpEx.'?search_id=egosearch') . '" class="nav" title="' . $lang['View_results'] . '">' . $userdata['user_posts'] . '</a>');
            $l_user_topics_total = sprintf($l_user_topics_total_s, '<a href="' . append_sid('search.'.$phpEx.'?search_id=egotopics') . '" class="nav" title="' . $lang['View_results'] . '">' . $total_user_topics . '</a>');
            $l_user_replies_total = sprintf($l_user_replies_total_s, '<a href="' . append_sid('search.'.$phpEx.'?search_id=egoreplies') . '" class="nav" title="' . $lang['View_results'] . '">' . $total_user_replies . '</a>');
            $l_user_unanswered_posts = sprintf($l_user_unanswered_posts_s, '<a href="' . append_sid('search.'.$phpEx.'?search_id=egounanswered') . '" class="nav" title="' . $lang['View_results'] . '">' . $user_unanswered_posts . '</a>');

            $l_new_posts_total = sprintf($l_new_posts_total_s, '<a href="' . append_sid('search.'.$phpEx.'?search_id=newposts') . '" class="nav" title="' . $lang['View_results'] . '">' . $total_new_posts . '</a>');
            $l_new_topics_total = sprintf($l_new_topics_total_s, '<a href="' . append_sid('search.'.$phpEx.'?search_id=newtopics') . '" class="nav" title="' . $lang['View_results'] . '">' . $total_new_topics . '</a>');
            $l_new_replies_total = sprintf($l_new_replies_total_s, '<a href="' . append_sid('search.'.$phpEx.'?search_id=newreplies') . '" class="nav" title="' . $lang['View_results'] . '">' . $total_new_replies . '</a>');
            $l_unanswered_posts = sprintf($l_unanswered_posts_s, '<a href="' . append_sid('search.'.$phpEx.'?search_id=unanswered') . '" class="nav" title="' . $lang['View_results'] . '">' . $total_unanswered_posts . '</a>');
            $l_announcement_total = sprintf($l_announcement_total_s, '<a href="' . append_sid('search.'.$phpEx.'?search_id=announce') . '" class="nav" title="' . $lang['View_results'] . '">' . $total_announcement_posts . '</a>');
            $l_new_announcement_posts = sprintf($l_new_announcement_posts_s, '<a href="' . append_sid('search.'.$phpEx.'?search_id=newannounce') . '" class="nav" title="' . $lang['View_results'] . '">' . $new_announcement_posts . '</a>');
            $l_announcement_posts = sprintf($l_announcement_posts_s, '<a href="' . append_sid('search.'.$phpEx.'?search_id=announce') . '" class="nav" title="' . $lang['View_results'] . '">' . $total_announcement_posts . '</a>');

            if ( $dashboarddata['display'] == 1 ) 
            { 
                $dashboard_details = '<span class="gensmall">' . $l_user_watched_topics . '<br />' . $l_user_posts_total . '<br />' . $l_user_unanswered_posts . '</span></td><td class="row1" align="left" valign="middle"><span class="gensmall">' . $l_new_posts_total . '<br />' . $l_unanswered_posts . '<br />' . $l_announcement_total . '</span>';
            }
            else if ( $dashboarddata['display'] == 2 ) 
            {
                $dashboard_details = '<span class="gensmall">' . $l_user_watched_topics . '<br />' . $l_user_topics_total . $l_user_replies_total . '<br />' . $l_user_unanswered_posts . '</span></td><td class="row1" align="left" valign="middle"><span class="gensmall">' . $l_new_topics_total . $l_new_replies_total . '<br />' . $l_unanswered_posts . '<br />' . $l_new_announcement_posts . $l_announcement_posts . '</span>';
            } 
            else
            {
                if ( $userdata['dashboard_mode'] ) 
                { 
                    $dashboard_details = '<span class="gensmall">' . $l_user_watched_topics . '<br />' . $l_user_topics_total . $l_user_replies_total . '<br />' . $l_user_unanswered_posts . '</span></td><td class="row1" align="left" valign="middle"><span class="gensmall">' . $l_new_topics_total . $l_new_replies_total . '<br />' . $l_unanswered_posts . '<br />' . $l_new_announcement_posts . $l_announcement_posts . '</span>';
                } 
                else
                { 
                    $dashboard_details = '<span class="gensmall">' . $l_user_watched_topics . '<br />' . $l_user_posts_total . '<br />' . $l_user_unanswered_posts . '</span></td><td class="row1" align="left" valign="middle"><span class="gensmall">' . $l_new_posts_total . '<br />' . $l_unanswered_posts . '<br />' . $l_announcement_total . '</span>';
                }
            }

            if ( $dashboarddata['avatars'] && $userdata['dashboard_avatar'] && $userdata['user_allowavatar'] && ( $board_config['allow_avatar_upload'] || $board_config['allow_avatar_local'] || $board_config['allow_avatar_remote'] ) ) 
            { 
                $dashboard_salutation = '<span class="gensmall"><table width="100%" cellpadding="0" cellspacing="0" border="0"><tr><td class="row1" align="left" valign="middle">' . $myavatar_img . '&nbsp;</td><td class="row1" align="left" valign="middle"><span class="gensmall">' . $lang['Welcome'] . $name_link . '<br />' . $l_user_private_message . $l_unread_private_message . '<br />' . $lang['Contact_admin'] . ': ' . $l_email_admin . ' :: ' . $l_pm_admin . '</span></td></tr></table></span>';
            } 
            else 
            { 
                $dashboard_salutation = '<span class="gensmall">' . $lang['Welcome'] . $name_link . '<br />' . $l_user_private_message . $l_unread_private_message . '<br />' . $lang['Contact_admin'] . ': ' . $l_email_admin . ' :: ' . $l_pm_admin . '</span>';
            } 
        } 
    }
}
//
// END MOD: My Dashboard Ultra by safeTsurfa
//

# 
#-----[ FIND ]------------------------------------ 
# 
	'L_USERGROUPS' => $lang['Usergroups'],

# 
#-----[ AFTER, ADD ]------------------------------------ 
# 
	//
	// START MOD: My Dashboard by safeTsurfa
	//
	'L_DASHBOARD' => $lang['Dashboard'],
	'L_DASHBOARD_SALUTATION' => $dashboard_salutation,
	'L_DASHBOARD_DETAILS' => $dashboard_details,
	'U_DASHBOARD' => $l_dashboard,
	//
	// END MOD: My Dashboard by safeTsurfa
	//

# 
#-----[ OPEN ]------------------------------------------ 
# 
includes/usercp_register.php

# 
#-----[ FIND ]------------------------------------------ 
# 
		$allowsmilies = ( isset($HTTP_POST_VARS['allowsmilies']) ) ? ( ($HTTP_POST_VARS['allowsmilies']) ? TRUE : 0 ) : $board_config['allow_smilies'];

# 
#-----[ AFTER, ADD ]------------------------------------------ 
# 
		//
		// BEGIN MOD: My Dashboard Ultra by safeTsurfa
		//
		$dashboardshow = ( isset($HTTP_POST_VARS['dashboardshow']) ) ? ( ($HTTP_POST_VARS['dashboardshow']) ? TRUE : 0 ) : TRUE; 
		$dashboardmode = ( isset($HTTP_POST_VARS['dashboardmode']) ) ? ( ($HTTP_POST_VARS['dashboardmode']) ? TRUE : 0 ) : TRUE; 
		$dashboardavatar = ( isset($HTTP_POST_VARS['dashboardavatar']) ) ? ( ($HTTP_POST_VARS['dashboardavatar']) ? TRUE : 0 ) : TRUE; 
		//
		// END MOD: My Dashboard Ultra by safeTsurfa
		//

# 
#-----[ FIND ]------------------------------------------ 
# 
		$allowsmilies = ( isset($HTTP_POST_VARS['allowsmilies']) ) ? ( ($HTTP_POST_VARS['allowsmilies']) ? TRUE : 0 ) : $userdata['user_allowsmile'];

# 
#-----[ AFTER, ADD ]------------------------------------------ 
# 
		//
		// BEGIN MOD: My Dashboard Ultra by safeTsurfa
		//
		$dashboardshow = ( isset($HTTP_POST_VARS['dashboardshow']) ) ? ( ($HTTP_POST_VARS['dashboardshow']) ? TRUE : 0 ) : $userdata['dashboard_show']; 
		$dashboardmode = ( isset($HTTP_POST_VARS['dashboardmode']) ) ? ( ($HTTP_POST_VARS['dashboardmode']) ? TRUE : 0 ) : $userdata['dashboard_mode']; 
		$dashboardavatar = ( isset($HTTP_POST_VARS['dashboardavatar']) ) ? ( ($HTTP_POST_VARS['dashboardavatar']) ? TRUE : 0 ) : $userdata['dashboard_avatar'];
		//
		// END MOD: My Dashboard Ultra by safeTsurfa
		//

# 
#-----[ FIND ]------------------------------------------ 
# 
			$sql = "UPDATE " . USERS_TABLE . "
				SET " . $username_sql . $passwd_sql . "user_email = '" . str_replace("\'", "''", $email) ."', user_icq = '" . str_replace("\'", "''", $icq) . "', user_website = '" . str_replace("\'", "''", $website) . "', user_occ = '" . str_replace("\'", "''", $occupation) . "', user_from = '" . str_replace("\'", "''", $location) . "', user_interests = '" . str_replace("\'", "''", $interests) . "', user_sig = '" . str_replace("\'", "''", $signature) . "', user_sig_bbcode_uid = '$signature_bbcode_uid', user_viewemail = $viewemail, user_aim = '" . str_replace("\'", "''", str_replace(' ', '+', $aim)) . "', user_yim = '" . str_replace("\'", "''", $yim) . "', user_msnm = '" . str_replace("\'", "''", $msn) . "', user_attachsig = $attachsig, user_allowsmile = $allowsmilies, user_allowhtml = $allowhtml, user_allowbbcode = $allowbbcode, user_allow_viewonline = $allowviewonline, user_notify = $notifyreply, user_notify_pm = $notifypm, user_popup_pm = $popup_pm, user_timezone = $user_timezone, user_dateformat = '" . str_replace("\'", "''", $user_dateformat) . "', user_lang = '" . str_replace("\'", "''", $user_lang) . "', user_style = $user_style, user_active = $user_active, user_actkey = '" . str_replace("\'", "''", $user_actkey) . "'" . $avatar_sql . "

# 
#-----[ IN-LINE FIND ]------------------------------------------ 
# 
user_allowbbcode = $allowbbcode

# 
#-----[ IN-LINE AFTER, ADD ]------------------------------------------ 
# 
, dashboard_show = $dashboardshow, dashboard_mode = $dashboardmode, dashboard_avatar = $dashboardavatar

# 
#-----[ FIND ]------------------------------------------ 
# 
			$sql = "INSERT INTO " . USERS_TABLE . "	(user_id, username, user_regdate, user_password, user_email, user_icq, user_website, user_occ, user_from, user_interests, user_sig, user_sig_bbcode_uid, user_avatar, user_avatar_type, user_viewemail, user_aim, user_yim, user_msnm, user_attachsig, user_allowsmile, user_allowhtml, user_allowbbcode, user_allow_viewonline, user_notify, user_notify_pm, user_popup_pm, user_timezone, user_dateformat, user_lang, user_style, user_level, user_allow_pm, user_active, user_actkey)

# 
#-----[ IN-LINE FIND ]------------------------------------------ 
# 
user_avatar_type

# 
#-----[ IN-LINE AFTER, ADD ]------------------------------------------ 
# 
, dashboard_show, dashboard_mode, dashboard_avatar

# 
#-----[ FIND ]------------------------------------------ 
# 
				VALUES ($user_id, '" . str_replace("\'", "''", $username) . "', " . time() . ", '" . str_replace("\'", "''", $new_password) . "', '" . str_replace("\'", "''", $email) . "', '" . str_replace("\'", "''", $icq) . "', '" . str_replace("\'", "''", $website) . "', '" . str_replace("\'", "''", $occupation) . "', '" . str_replace("\'", "''", $location) . "', '" . str_replace("\'", "''", $interests) . "', '" . str_replace("\'", "''", $signature) . "', '$signature_bbcode_uid', $avatar_sql, $viewemail, '" . str_replace("\'", "''", str_replace(' ', '+', $aim)) . "', '" . str_replace("\'", "''", $yim) . "', '" . str_replace("\'", "''", $msn) . "', $attachsig, $allowsmilies, $allowhtml, $allowbbcode, $allowviewonline, $notifyreply, $notifypm, $popup_pm, $user_timezone, '" . str_replace("\'", "''", $user_dateformat) . "', '" . str_replace("\'", "''", $user_lang) . "', $user_style, 0, 1, ";

# 
#-----[ IN-LINE FIND ]------------------------------------------ 
# 
$avatar_sql

# 
#-----[ IN-LINE AFTER, ADD ]------------------------------------------ 
# 
, $dashboardshow, $dashboardmode, $dashboardavatar

# 
#-----[ FIND ]------------------------------------------ 
# 
	$allowviewonline = $userdata['user_allow_viewonline'];

# 
#-----[ AFTER, ADD ]------------------------------------------ 
# 
	//
	// BEGIN MOD: My Dashboard Ultra by safeTsurfa
	//
	$dashboardshow = $userdata['dashboard_show'];
	$dashboardmode = $userdata['dashboard_mode'];
	$dashboardavatar = $userdata['dashboard_avatar'];
	//
	// END MOD: My Dashboard Ultra by safeTsurfa
	//

# 
#-----[ FIND ]------------------------------------------ 
# 
	display_avatar_gallery($mode, $avatar_category, $user_id, $email, $current_email, $coppa, $username, $email, &$new_password, &$cur_password, $password_confirm, $icq, $aim, $msn, $yim, $website, $location, $occupation, $interests, $signature, $viewemail, $notifypm, $popup_pm, $notifyreply, $attachsig, $allowhtml, $allowbbcode, $allowsmilies, $allowviewonline, $user_style, $user_lang, $user_timezone, $user_dateformat, $userdata['session_id']);

# 
#-----[ IN-LINE FIND ]------------------------------------------ 
# 
$signature

# 
#-----[ IN-LINE AFTER, ADD ]------------------------------------------ 
# 
, $dashboardshow, $dashboardmode, $dashboardavatar

# 
#-----[ FIND ]------------------------------------------ 
# 
		'SMILIES_STATUS' => $smilies_status,

# 
#-----[ AFTER, ADD ]------------------------------------------ 
# 
		//
		// BEGIN MOD: My Dashboard Ultra by safeTsurfa
		//
		'DASHBOARD_SHOW_YES' => ( $dashboardshow ) ? 'checked="checked"' : '',
		'DASHBOARD_SHOW_NO' => ( !$dashboardshow ) ? 'checked="checked"' : '',
		'DASHBOARD_MODE_BASIC' => ( !$dashboardmode ) ? 'checked="checked"' : '',
		'DASHBOARD_MODE_ADVANCED' => ( $dashboardmode ) ? 'checked="checked"' : '',
		'DASHBOARD_AVATAR_YES' => ( $dashboardavatar ) ? 'checked="checked"' : '',
		'DASHBOARD_AVATAR_NO' => ( !$dashboardavatar ) ? 'checked="checked"' : '',
		//
		// END MOD: My Dashboard Ultra by safeTsurfa
		//

# 
#-----[ FIND ]------------------------------------------ 
# 
		'L_ALWAYS_ADD_SIGNATURE' => $lang['Always_add_sig'],

# 
#-----[ AFTER, ADD ]------------------------------------------ 
# 
		//
		// BEGIN MOD: My Dashboard Ultra by safeTsurfa
		//
		'L_DASHBOARD_EXPLAIN' => $lang['Dashboard_explain'],
		'L_DASHBOARD_SHOW' => $lang['Dashboard_show'],
		'L_DASHBOARD_SHOW_EXPLAIN' => $lang['Dashboard_show_explain'],
		'L_DASHBOARD_MODE' => $lang['Dashboard_mode'],
		'L_DASHBOARD_MODE_EXPLAIN' => $lang['Dashboard_mode_explain'],
		'L_DASHBOARD_BASIC' => $lang['Dashboard_basic'],
		'L_DASHBOARD_ADVANCED' => $lang['Dashboard_advanced'],
		'L_DASHBOARD_AVATAR' => $lang['Dashboard_avatar'],
		'L_DASHBOARD_AVATAR_EXPLAIN' => $lang['Dashboard_avatar_explain'],
		//
		// END MOD: My Dashboard Ultra by safeTsurfa
		//

# 
#-----[ FIND ]------------------------------------------ 
# 
	//
	// This is another cheat using the block_var capability
	// of the templates to 'fake' an IF...ELSE...ENDIF solution
	// it works well :)
	//
	if ( $mode != 'register' )
	{

# 
#-----[ AFTER, ADD ]------------------------------------------ 
# 
		if ( $dashboarddata['active'] && $dashboarddata['display'] == 3 )
		{
			$template->assign_block_vars('switch_dashboard_active.switch_dashboard_display', array());
		}

# 
#-----[ FIND ]------------------------------------------ 
# 
		if ( $userdata['user_allowavatar'] && ( $board_config['allow_avatar_upload'] || $board_config['allow_avatar_local'] || $board_config['allow_avatar_remote'] ) )
		{

# 
#-----[ AFTER, ADD ]------------------------------------------ 
# 
			if ( $dashboarddata['active'] && $dashboarddata['avatars'] )
			{
				$template->assign_block_vars('switch_dashboard_active.switch_dashboard_avatar', array());
			}

# 
#-----[ OPEN ]------------------------------------------ 
# 
language/lang_english/lang_main.php

# 
#-----[ FIND ]------------------------------------ 
# 
$lang['Replies'] = 'Replies';

# 
#-----[ BEFORE, ADD ]------------------------------------ 
# 
$lang['Reply'] = 'Reply';

# 
#-----[ FIND ]------------------------------------ 
# 
//
// That's all, Folks!
// -------------------------------------------------

?>

# 
#-----[ BEFORE, ADD ]------------------------------------ 
# 
//
// My Dashboard Ultra by safeTsurfa
//
$lang['Dashboard_minimize'] = 'Minimize dashboard';
$lang['Dashboard_restore'] = 'Restore dashboard';

# 
#-----[ OPEN ]------------------------------------------ 
# 
templates/subSilver/overall_header.tpl

# 
#-----[ FIND ]------------------------------------ 
# 
					</tr>
				</table></td>
			</tr>
		</table>

		<br />

# 
#-----[ AFTER, ADD ]------------------------------------ 
# 
<!-- BEGIN switch_user_logged_out -->
<form method="post" action="{S_LOGIN_ACTION}">
  <table width="100%" cellpadding="3" cellspacing="1" border="0" class="forumline">
      <tr> 
         <td class="catHead" height="28"><a name="login"></a><span class="cattitle">{L_LOGIN_LOGOUT}</span></td>
      </tr>
      <tr> 
         <td class="row1" align="center" valign="middle"><span class="gensmall">&nbsp;{L_USERNAME}: 
            <input class="post" type="text" name="username" size="10" />
            &nbsp;&nbsp;&nbsp;{L_PASSWORD}: 
            <input class="post" type="password" name="password" size="10" maxlength="32" />
            &nbsp; &nbsp;<input type="submit" class="mainoption" name="login" value="{L_LOGIN}" />&nbsp;<br />
            &nbsp;{L_AUTO_LOGIN}&nbsp;<input class="text" type="checkbox" name="autologin" checked="checked" />
            &nbsp;&nbsp;&nbsp;Not a member? <a href="{U_REGISTER}" class="genmed"><b>{L_REGISTER}</b>
      </tr>
   </table>
</form>
<!-- END switch_user_logged_out -->

<!-- BEGIN switch_dashboard_active -->
<!-- BEGIN switch_dashboard_show -->
<table width="100%" cellpadding="3" cellspacing="1" border="0" class="forumline">
   <tr> 
      <td colspan="3" class="catHead" align="left" height="28"><span class="cattitle">{U_DASHBOARD}</span></td> 
   </tr> 
<!-- BEGIN switch_dashboard_open -->
   <tr> 
      <td class="row1" align="left" valign="middle">{L_DASHBOARD_SALUTATION}</td>
      <td class="row1" align="left" valign="middle">{L_DASHBOARD_DETAILS}</td>
   </tr> 
<!-- END switch_dashboard_open -->
</table> 
<!-- END switch_dashboard_show -->
<!-- END switch_dashboard_active -->

# 
#-----[ OPEN ]------------------------------------------ 
# 
templates/subSilver/profile_add_body.tpl 

#
#-----[ FIND ]------------------------------------------ 
# 
	<tr> 
	  <th class="thSides" colspan="2" height="25" valign="middle">{L_PREFERENCES}</th>
	</tr>

# 
#-----[ BEFORE, ADD ]------------------------------------------ 
# 
	<!-- BEGIN switch_dashboard_active -->
	<tr> 
	  <th class="thSides" colspan="2" height="25" valign="middle">{L_DASHBOARD}</th>
	</tr>
	<tr> 
	  <td class="row2" colspan="2"><span class="gensmall">{L_DASHBOARD_EXPLAIN}</span></td>
	</tr>
	<tr>
	  <td class="row1"><span class="gen">{L_DASHBOARD_SHOW}:</span><br />
	  <span class="gensmall">{L_DASHBOARD_SHOW_EXPLAIN}</span></td>
	  <td class="row2">
		<input type="radio" name="dashboardshow" value="1" {DASHBOARD_SHOW_YES} />
		<span class="gen">{L_YES}</span>&nbsp;&nbsp; 
		<input type="radio" name="dashboardshow" value="0" {DASHBOARD_SHOW_NO} />
		<span class="gen">{L_NO}</span></td>
	</tr>
	<!-- BEGIN switch_dashboard_display -->
	<tr> 
	  <td class="row1"><span class="gen">{L_DASHBOARD_MODE}:</span><br />
	  <span class="gensmall">{L_DASHBOARD_MODE_EXPLAIN}</span></td>
	  <td class="row2">
		<input type="radio" name="dashboardmode" value="0" {DASHBOARD_MODE_BASIC} />
		<span class="gen">{L_DASHBOARD_BASIC}</span>&nbsp;&nbsp; 
		<input type="radio" name="dashboardmode" value="1" {DASHBOARD_MODE_ADVANCED} />
		<span class="gen">{L_DASHBOARD_ADVANCED}</span></td>
	</tr>
	<!-- END switch_dashboard_display -->
	<!-- BEGIN switch_dashboard_avatar -->
	<tr> 
	  <td class="row1"><span class="gen">{L_DASHBOARD_AVATAR}:</span><br />
	  <span class="gensmall">{L_DASHBOARD_AVATAR_EXPLAIN}</span></td>
	  <td class="row2">
		<input type="radio" name="dashboardavatar" value="1" {DASHBOARD_AVATAR_YES} />
		<span class="gen">{L_YES}</span>&nbsp;&nbsp; 
		<input type="radio" name="dashboardavatar" value="0" {DASHBOARD_AVATAR_NO} />
		<span class="gen">{L_NO}</span></td>
	</tr>
	<!-- END switch_dashboard_avatar -->
	<tr> 
	  <td class="catSides" colspan="2" height="28">&nbsp;</td>
	</tr>
	<!-- END switch_dashboard_active -->

# 
#-----[ SAVE/CLOSE ALL FILES ]------------------------------------------ 
# 
# EoM