<?php
/***************************************************************************
 *                               functions_dashboard.php
 *                            -------------------
 *   begin                : Wednesday, Aug 25, 2004
 *   copyright            : (C) 2004 safeTsurfa
 *   email                : safetsurfa@hotmail.com
 *
 *   $Id: functions_dashboard.php,v 1.00.0.0 2004/08/31 00:00:00 safeTsurfa Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/

//
// Pick an email contact, 
//
function emails_select($default, $select_name = 'emails')
{
   global $db;

   $sql = "SELECT username, rank_title
      FROM " . USERS_TABLE . " u, " . RANKS_TABLE . " r
      WHERE r.rank_special = 1
      AND r.rank_id = u.user_rank
      ORDER BY r.rank_id, u.username ASC";
   if ( !($result = $db->sql_query($sql)) )
   {
      message_die(GENERAL_ERROR, "Couldn't query data tables", "", __LINE__, __FILE__, $sql);
   }

   $emails_select = '<select name="' . $select_name . '">';
   while ( $row = $db->sql_fetchrow($result) )
   {
      $selected = ( $row['username'] == $default ) ? ' selected="selected"' : '';

      $emails_select .= '<option value="' . $row['username'] . '"' . $selected . '>' . $row['username'] . ' (' . $row['rank_title'] . ')</option>';
   }
   $emails_select .= "</select>";

   return $emails_select;
}

//
// Pick a message contact, 
//
function messages_select($default, $select_name = 'messages')
{
   global $db;

   $sql = "SELECT username, rank_title
      FROM " . USERS_TABLE . " u, " . RANKS_TABLE . " r
      WHERE r.rank_special = 1
      AND r.rank_id = u.user_rank
      ORDER BY r.rank_id, u.username ASC";
   if ( !($result = $db->sql_query($sql)) )
   {
      message_die(GENERAL_ERROR, "Couldn't query data tables", "", __LINE__, __FILE__, $sql);
   }

   $messages_select = '<select name="' . $select_name . '">';
   while ( $row = $db->sql_fetchrow($result) )
   {
      $selected = ( $row['username'] == $default ) ? ' selected="selected"' : '';

      $messages_select .= '<option value="' . $row['username'] . '"' . $selected . '>' . $row['username'] . ' (' . $row['rank_title'] . ')</option>';
   }
   $messages_select .= "</select>";

   return $messages_select;
}

?>
