<?php

/***************************************************************************
 *                            lang_dashboard.php [English]
 *                              -------------------
 *     begin                : Saturday Sept 04 2004
 *     copyright            : (C) 2004 safeTsurfa
 *     email                : safetsurfa@hotmail.com
 *
 *     $Id: lang_dashboard.php,v 1.00.0.0 2004/09/04 00:00:00 safeTsurfa Exp $
 *
 ****************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

//
// These two lines must be copied into lang_main.php
//
// $lang['Dashboard_minimize'] = 'Minimize dashboard';
// $lang['Dashboard_restore'] = 'Restore dashboard';
//

$lang['Reply'] = 'Reply';
$lang['Dashboard'] = "My Dashboard"; 

//
// Used in the left column of the dashboard console
//
$lang['Welcome'] = "Welcome back ";
$lang['Contact_admin'] = "Contact Admin";
$lang['User_messages_zero_total'] = "My inbox: 0 new"; // New messages zero count
$lang['User_message_total'] = "My inbox: %s new"; // New message count
$lang['User_messages_total'] = "My inbox: %s new"; // New messages count
$lang['Unread_messages_zero_total'] = " :: 0 unread"; // Unread messages zero count
$lang['Unread_message_total'] = " :: %s unread"; // Unread message count
$lang['Unread_messages_total'] = " :: %s unread"; // Unread messages count

//
// Used in the central column of the dashboard console
//
$lang['User_watched_topics_zero_total'] = "My watched topics list: 0 topics"; // User watched zero topics
$lang['User_watched_topic_total'] = "My watched topics list: %s topic"; // User watched topic
$lang['User_watched_topics_total'] = "My watched topics list: %s topics"; // User watched topics
$lang['User_posts_zero_total'] = "My posting history: 0 posts"; // User posts zero count
$lang['User_post_total'] = "My posting history: %s post"; // User post count
$lang['User_posts_total'] = "My posting history: %s posts"; // User posts count
$lang['User_topics_zero_total'] = "My posts: 0 topics"; // User topics zero count
$lang['User_topic_total'] = "My posts: %s  topic"; // User topic count
$lang['User_topics_total'] = "My posts: %s  topics"; // User topics count
$lang['User_replies_zero_total'] = " :: 0 replies"; // User replies zero count
$lang['User_reply_total'] = " :: %s reply"; // User reply count
$lang['User_replies_total'] = " :: %s replies"; // User replies count
$lang['User_unanswered_posts_zero_total'] = "My unanswered posts: 0 topics"; // User unanswered posts zero count
$lang['User_unanswered_post_total'] = "My unanswered posts: %s topic"; // User unanswered post count
$lang['User_unanswered_posts_total'] = "My unanswered posts: %s topics"; // User unanswered posts count

//
// Used in the right column of the dashboard console
//
$lang['New_posts_zero_total'] = "There are 0 posts since last visit"; // New posts zero count
$lang['New_post_total'] = "There is %s post since last visit"; // New post count
$lang['New_posts_total'] = "There are %s posts since last visit"; // New posts count
$lang['New_topics_zero_total'] = "New posts: 0 topics"; // New topics zero count
$lang['New_topic_total'] = "New posts: %s topic"; // New topic count
$lang['New_topics_total'] = "New posts: %s topics"; // New topics count
$lang['New_replies_zero_total'] = " :: 0 replies"; // New replies zero count
$lang['New_reply_total'] = " :: %s reply"; // New reply count
$lang['New_replies_total'] = " :: %s replies"; // New replies count
$lang['Unanswered_posts_zero_total'] = "Total unanswered posts: 0 topics"; // Unanswered posts zero count
$lang['Unanswered_post_total'] = "Total unanswered posts: %s topic"; // Unanswered post count
$lang['Unanswered_posts_total'] = "Total unanswered posts: %s topics"; // Unanswered posts count
$lang['Total_announcements_zero_total'] = "There are 0 announcements"; // Total announcements zero count
$lang['Total_announcement_total'] = "There is %s announcement total"; // Total announcement count
$lang['Total_announcements_total'] = "There are %s announcements total"; // Total announcements  count
$lang['New_announcement_posts_zero_total'] = "Announcements: 0 new"; // Announcements zero count
$lang['New_announcement_post_total'] = "Announcements: %s new"; // Announcement count
$lang['New_announcement_posts_total'] = "Announcements: %s new"; // Announcements count
$lang['Announcement_posts_zero_total'] = " :: 0 total"; // Announcements zero count
$lang['Announcement_posts_total'] = " :: %s total"; // Announcements count

//
// Used for the dashboard preferences panel in user profiles
//
$lang['Dashboard_explain'] = "Displays posting statistics and message alerts at the top of the board.";
$lang['Dashboard_show'] = "Show the dashboard";
$lang['Dashboard_show_explain'] = "Displays or hides the dashboard.";
$lang['Dashboard_mode'] = "Select display mode";
$lang['Dashboard_mode_explain'] = "Displays simplified or detailed results.";
$lang['Dashboard_basic'] = "Basic";
$lang['Dashboard_advanced'] = "Advanced";
$lang['Dashboard_avatar'] = "Show personal avatar";
$lang['Dashboard_avatar_explain'] = "Displays the avatar in the dashboard.";

//
// Used for the configuration page in the Administration Panel
//
$lang['Dashboard_title'] = 'My Dashboard Ultra';
$lang['Dashboard_both'] = 'Both';
$lang['Dashboard_title_explain'] = 'Configure the dashboard and select contacts for e-mail and messages. Settings here override user preferences. A restricted setting is hidden in the profile. If the dashboard is disabled, the preferences panel is removed from view.';
$lang['Dashboard_config_explain'] = 'Settings selected here will override personal preferences in user profiles.';
$lang['Dashboard_allow'] = 'Dashboard activation';
$lang['Dashboard_allow_explain'] = 'Enables or disables the dashboard.';
$lang['Dashboard_display_explain'] = 'Restricts dashboard display mode. \'Both\' allows users to select mode in the profile.';
$lang['Dashboard_avatars'] = 'Allow avatar display';
$lang['Dashboard_avatars_explain'] = 'If avatars are enabled on the board, allows the user\'s avatar to show in the dashboard.';
$lang['Dashboard_contact_explain'] = 'Select a site administrator or moderator to receive e-mail or messages.';
$lang['Dashboard_email'] = 'Select who will receive e-mail';
$lang['Dashboard_pm'] = 'Select who will receive messages';
$lang['Dashboard_copyright'] = 'My Dashboard Ultra %s &copy; 2004 <a href="http://www.safetsurfa.co.uk" target="_phpbb" class="copyright">safeTsurfa</a><br />'; // the %s is the version number
$lang['Dashboard_updated'] = 'Dashboard configuration successfully updated';
$lang['Click_return_dashboard'] = 'Click %sHere%s to return to the configuration page';

//
// Error messages
//
$lang['Dashboard_general_error'] = 'Could not query dashboard configuration data';
$lang['Dashboard_email_error'] = 'Could not select email contact';
$lang['Dashboard_message_error'] = 'Could not select message contact';

//
// That's all Folks!
// -------------------------------------------------

?>